<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-pragma">{-# LANGUAGE FlexibleContexts  #-}</span><span>
</span><span id="line-2"></span><span class="hs-pragma">{-# LANGUAGE OverloadedStrings #-}</span><span>
</span><span id="line-3"></span><span class="hs-pragma">{-# LANGUAGE StaticPointers    #-}</span><span>
</span><span id="line-4"></span><span class="hs-pragma">{-# LANGUAGE TypeFamilies      #-}</span><span>
</span><span id="line-5"></span><span>
</span><span id="line-6"></span><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Hyperion.Bootstrap.CFTBound.RemoteCompute</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-7"></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>              </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">liftIO</span></span><span class="hs-special">)</span><span>
</span><span id="line-9"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Control.Monad.Reader</span></span><span>                </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">asks</span></span><span class="hs-special">)</span><span>
</span><span id="line-10"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Aeson</span></span><span>                          </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">ToJSON</span></span><span class="hs-special">)</span><span>
</span><span id="line-11"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Binary</span></span><span>                         </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Binary</span></span><span class="hs-special">)</span><span>
</span><span id="line-12"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Time</span></span><span>                           </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">NominalDiffTime</span></span><span class="hs-special">)</span><span>
</span><span id="line-13"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Hyperion</span></span><span>                            </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Cluster</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">Dict</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">Job</span></span><span class="hs-special">,</span><span>
</span><span id="line-14"></span><span>                                                      </span><span class="annot"><span class="hs-identifier">Static</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">cAp</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">cPure</span></span><span class="hs-special">,</span><span>
</span><span id="line-15"></span><span>                                                      </span><span class="annot"><span class="hs-identifier">clusterJobOptions</span></span><span class="hs-special">,</span><span>
</span><span id="line-16"></span><span>                                                      </span><span class="annot"><span class="hs-identifier">newWorkDir</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">ptrAp</span></span><span class="hs-special">,</span><span>
</span><span id="line-17"></span><span>                                                      </span><span class="annot"><span class="hs-identifier">remoteEvalJob</span></span><span class="hs-special">)</span><span>
</span><span id="line-18"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Compute.html"><span class="hs-identifier">Hyperion.Bootstrap.CFTBound.Compute</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Compute.html#computeCFTBoundWithFileTreatment"><span class="hs-identifier">computeCFTBoundWithFileTreatment</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-19"></span><span>                                                      </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Compute.html#continueSDPBCheckpointed"><span class="hs-identifier">continueSDPBCheckpointed</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-20"></span><span>                                                      </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Compute.html#defaultCFTBoundFiles"><span class="hs-identifier">defaultCFTBoundFiles</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-21"></span><span>                                                      </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Compute.html#keepOutAndCheckpoint"><span class="hs-identifier">keepOutAndCheckpoint</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-22"></span><span>                                                      </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Compute.html#setFixedTimeLimit"><span class="hs-identifier">setFixedTimeLimit</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-23"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html"><span class="hs-identifier">Hyperion.Bootstrap.CFTBound.Types</span></a></span><span>   </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#BuildInJob"><span class="hs-identifier">BuildInJob</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#CFTBound"><span class="hs-identifier">CFTBound</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-24"></span><span>                                                      </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#SDPFetchBuildConfig"><span class="hs-identifier">SDPFetchBuildConfig</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-25"></span><span>                                                      </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#CFTBoundFiles"><span class="hs-identifier">CFTBoundFiles</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-26"></span><span>                                                      </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#BoundFileTreatment"><span class="hs-identifier">BoundFileTreatment</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-27"></span><span>                                                      </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#ToSDP"><span class="hs-identifier">ToSDP</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-28"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Hyperion.Database</span></span><span>                   </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">DB</span></span><span>
</span><span id="line-29"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Hyperion.Log</span></span><span>                        </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">Log</span></span><span>
</span><span id="line-30"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Hyperion.Slurm</span></span><span>                      </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">Slurm</span></span><span>
</span><span id="line-31"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">SDPB.Solver</span></span><span>                         </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">SDPB</span></span><span>
</span><span id="line-32"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Type.Reflection</span></span><span>                     </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Typeable</span></span><span class="hs-special">)</span><span>
</span><span id="line-33"></span><span>
</span><span id="line-34"></span><span id="local-6989586621679448409"><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.RemoteCompute.html#remoteComputeBound"><span class="hs-identifier hs-type">remoteComputeBound</span></a></span><span>
</span><span id="line-35"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">(</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Typeable</span></span><span> </span><span class="annot"><a href="#local-6989586621679448409"><span class="hs-identifier hs-type">b</span></a></span><span>
</span><span id="line-36"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Show</span></span><span> </span><span class="annot"><a href="#local-6989586621679448409"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-37"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">ToJSON</span></span><span> </span><span class="annot"><a href="#local-6989586621679448409"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-38"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#ToSDP"><span class="hs-identifier hs-type">ToSDP</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679448409"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-39"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Binary</span></span><span> </span><span class="annot"><a href="#local-6989586621679448409"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-40"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#SDPFetchBuildConfig"><span class="hs-identifier hs-type">SDPFetchBuildConfig</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679448409"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-41"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#BuildInJob"><span class="hs-identifier hs-type">BuildInJob</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679448409"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-42"></span><span>     </span><span class="hs-special">)</span><span>
</span><span id="line-43"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#CFTBound"><span class="hs-identifier hs-type">CFTBound</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span> </span><span class="annot"><a href="#local-6989586621679448409"><span class="hs-identifier hs-type">b</span></a></span><span>
</span><span id="line-44"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Cluster</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDPB.Output</span></span></span><span>
</span><span id="line-45"></span><span id="remoteComputeBound"><span class="annot"><span class="annottext">remoteComputeBound :: CFTBound Int b -&gt; Cluster Output
</span><a href="Hyperion.Bootstrap.CFTBound.RemoteCompute.html#remoteComputeBound"><span class="hs-identifier hs-var hs-var">remoteComputeBound</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-46"></span><span>  </span><span class="annot"><span class="annottext">BoundFileTreatment
-&gt; (FilePath -&gt; CFTBoundFiles) -&gt; CFTBound Int b -&gt; Cluster Output
forall b.
(Typeable b, Static (Show b), Static (ToJSON b), Static (ToSDP b),
 Static (Binary b), Static (SDPFetchBuildConfig b),
 Static (BuildInJob b)) =&gt;
BoundFileTreatment
-&gt; (FilePath -&gt; CFTBoundFiles) -&gt; CFTBound Int b -&gt; Cluster Output
</span><a href="Hyperion.Bootstrap.CFTBound.RemoteCompute.html#remoteComputeBoundWithFileTreatment"><span class="hs-identifier hs-var">remoteComputeBoundWithFileTreatment</span></a></span><span> </span><span class="annot"><span class="annottext">BoundFileTreatment
</span><a href="Hyperion.Bootstrap.CFTBound.Compute.html#keepOutAndCheckpoint"><span class="hs-identifier hs-var">keepOutAndCheckpoint</span></a></span><span> </span><span class="annot"><span class="annottext">FilePath -&gt; CFTBoundFiles
</span><a href="Hyperion.Bootstrap.CFTBound.Compute.html#defaultCFTBoundFiles"><span class="hs-identifier hs-var">defaultCFTBoundFiles</span></a></span><span>
</span><span id="line-47"></span><span>
</span><span id="line-48"></span><span id="local-6989586621679448490"><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.RemoteCompute.html#remoteComputeBoundWithFileTreatment"><span class="hs-identifier hs-type">remoteComputeBoundWithFileTreatment</span></a></span><span>
</span><span id="line-49"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">(</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Typeable</span></span><span> </span><span class="annot"><a href="#local-6989586621679448490"><span class="hs-identifier hs-type">b</span></a></span><span>
</span><span id="line-50"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Show</span></span><span> </span><span class="annot"><a href="#local-6989586621679448490"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-51"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">ToJSON</span></span><span> </span><span class="annot"><a href="#local-6989586621679448490"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-52"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#ToSDP"><span class="hs-identifier hs-type">ToSDP</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679448490"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-53"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Binary</span></span><span> </span><span class="annot"><a href="#local-6989586621679448490"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-54"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#SDPFetchBuildConfig"><span class="hs-identifier hs-type">SDPFetchBuildConfig</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679448490"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-55"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#BuildInJob"><span class="hs-identifier hs-type">BuildInJob</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679448490"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-56"></span><span>     </span><span class="hs-special">)</span><span>
</span><span id="line-57"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#BoundFileTreatment"><span class="hs-identifier hs-type">BoundFileTreatment</span></a></span><span>
</span><span id="line-58"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">FilePath</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#CFTBoundFiles"><span class="hs-identifier hs-type">CFTBoundFiles</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#CFTBound"><span class="hs-identifier hs-type">CFTBound</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span> </span><span class="annot"><a href="#local-6989586621679448490"><span class="hs-identifier hs-type">b</span></a></span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Cluster</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDPB.Output</span></span></span><span>
</span><span id="line-61"></span><span id="remoteComputeBoundWithFileTreatment"><span class="annot"><span class="annottext">remoteComputeBoundWithFileTreatment :: BoundFileTreatment
-&gt; (FilePath -&gt; CFTBoundFiles) -&gt; CFTBound Int b -&gt; Cluster Output
</span><a href="Hyperion.Bootstrap.CFTBound.RemoteCompute.html#remoteComputeBoundWithFileTreatment"><span class="hs-identifier hs-var hs-var">remoteComputeBoundWithFileTreatment</span></a></span></span><span> </span><span id="local-6989586621679448406"><span class="annot"><span class="annottext">BoundFileTreatment
</span><a href="#local-6989586621679448406"><span class="hs-identifier hs-var">treatment</span></a></span></span><span> </span><span id="local-6989586621679448405"><span class="annot"><span class="annottext">FilePath -&gt; CFTBoundFiles
</span><a href="#local-6989586621679448405"><span class="hs-identifier hs-var">mkFiles</span></a></span></span><span> </span><span id="local-6989586621679448404"><span class="annot"><span class="annottext">CFTBound Int b
</span><a href="#local-6989586621679448404"><span class="hs-identifier hs-var">cftBound</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-62"></span><span>  </span><span id="local-6989586621679448403"><span class="annot"><span class="annottext">FilePath
</span><a href="#local-6989586621679448403"><span class="hs-identifier hs-var">workDir</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">CFTBound Int b -&gt; ReaderT ClusterEnv Process FilePath
forall a env (m :: * -&gt; *).
(Binary a, Typeable a, ToJSON a, HasProgramInfo env, HasDB env,
 MonadReader env m, MonadIO m, MonadCatch m) =&gt;
a -&gt; m FilePath
</span><span class="hs-identifier hs-var">newWorkDir</span></span><span> </span><span class="annot"><span class="annottext">CFTBound Int b
</span><a href="#local-6989586621679448404"><span class="hs-identifier hs-var">cftBound</span></a></span><span>
</span><span id="line-63"></span><span>  </span><span id="local-6989586621679448402"><span class="annot"><span class="annottext">NominalDiffTime
</span><a href="#local-6989586621679448402"><span class="hs-identifier hs-var">jobTime</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">(ClusterEnv -&gt; NominalDiffTime)
-&gt; ReaderT ClusterEnv Process NominalDiffTime
forall r (m :: * -&gt; *) a. MonadReader r m =&gt; (r -&gt; a) -&gt; m a
</span><span class="hs-identifier hs-var">asks</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">SbatchOptions -&gt; NominalDiffTime
</span><span class="hs-identifier hs-var hs-var">Slurm.time</span></span><span> </span><span class="annot"><span class="annottext">(SbatchOptions -&gt; NominalDiffTime)
-&gt; (ClusterEnv -&gt; SbatchOptions) -&gt; ClusterEnv -&gt; NominalDiffTime
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">ClusterEnv -&gt; SbatchOptions
</span><span class="hs-identifier hs-var hs-var">clusterJobOptions</span></span><span class="hs-special">)</span><span>
</span><span id="line-64"></span><span>  </span><span id="local-6989586621679448399"><span class="annot"><span class="annottext">Output
</span><a href="#local-6989586621679448399"><span class="hs-identifier hs-var">result</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span>
</span><span id="line-65"></span><span>    </span><span class="annot"><span class="annottext">(FilePath, Params) -&gt; Cluster Output -&gt; Cluster Output
forall (m :: * -&gt; *) a.
(MonadIO m, Show a) =&gt;
a -&gt; m Output -&gt; m Output
</span><a href="Hyperion.Bootstrap.CFTBound.Compute.html#continueSDPBCheckpointed"><span class="hs-identifier hs-var">continueSDPBCheckpointed</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">FilePath
</span><a href="#local-6989586621679448403"><span class="hs-identifier hs-var">workDir</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">CFTBound Int b -&gt; Params
forall prec a. CFTBound prec a -&gt; Params
</span><a href="Hyperion.Bootstrap.CFTBound.Types.html#%24sel%3AsolverParams%3ACFTBound"><span class="hs-identifier hs-var hs-var">solverParams</span></a></span><span> </span><span class="annot"><span class="annottext">CFTBound Int b
</span><a href="#local-6989586621679448404"><span class="hs-identifier hs-var">cftBound</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">(Cluster Output -&gt; Cluster Output)
-&gt; Cluster Output -&gt; Cluster Output
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-66"></span><span>    </span><span class="annot"><span class="annottext">Closure (Job Output) -&gt; Cluster Output
forall b.
(Static (Binary b), Typeable b) =&gt;
Closure (Job b) -&gt; Cluster b
</span><span class="hs-identifier hs-var">remoteEvalJob</span></span><span> </span><span class="annot"><span class="annottext">(Closure (Job Output) -&gt; Cluster Output)
-&gt; Closure (Job Output) -&gt; Cluster Output
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-67"></span><span>    </span><span class="hs-keyword">static</span><span> </span><span class="annot"><span class="annottext">Dict
  (Show b, Typeable b, ToJSON b, Static (ToSDP b), Static (Binary b),
   Static (SDPFetchBuildConfig b), BuildInJob b)
-&gt; BoundFileTreatment
-&gt; NominalDiffTime
-&gt; CFTBound Int b
-&gt; CFTBoundFiles
-&gt; Job Output
forall b.
Dict
  (Show b, Typeable b, ToJSON b, Static (ToSDP b), Static (Binary b),
   Static (SDPFetchBuildConfig b), BuildInJob b)
-&gt; BoundFileTreatment
-&gt; NominalDiffTime
-&gt; CFTBound Int b
-&gt; CFTBoundFiles
-&gt; Job Output
</span><a href="Hyperion.Bootstrap.CFTBound.RemoteCompute.html#computeWithTimeLimit"><span class="hs-identifier hs-var">computeWithTimeLimit</span></a></span><span> </span><span class="annot"><span class="annottext">StaticPtr
  (Dict
     (Show b, Typeable b, ToJSON b, Static (ToSDP b), Static (Binary b),
      Static (SDPFetchBuildConfig b), BuildInJob b)
   -&gt; BoundFileTreatment
   -&gt; NominalDiffTime
   -&gt; CFTBound Int b
   -&gt; CFTBoundFiles
   -&gt; Job Output)
-&gt; Closure
     (Dict
        (Show b, Typeable b, ToJSON b, Static (ToSDP b), Static (Binary b),
         Static (SDPFetchBuildConfig b), BuildInJob b))
-&gt; Closure
     (BoundFileTreatment
      -&gt; NominalDiffTime
      -&gt; CFTBound Int b
      -&gt; CFTBoundFiles
      -&gt; Job Output)
forall a b.
(Typeable a, Typeable b) =&gt;
StaticPtr (a -&gt; b) -&gt; Closure a -&gt; Closure b
</span><span class="hs-operator hs-var">`ptrAp`</span></span><span>
</span><span id="line-68"></span><span>    </span><span class="annot"><span class="annottext">Closure
  (Dict
     (Show b, Typeable b, ToJSON b, Static (ToSDP b), Static (Binary b),
      Static (SDPFetchBuildConfig b), BuildInJob b))
forall (c :: Constraint). Static c =&gt; Closure (Dict c)
</span><span class="hs-identifier hs-var">closureDict</span></span><span> </span><span class="annot"><span class="annottext">Closure
  (BoundFileTreatment
   -&gt; NominalDiffTime
   -&gt; CFTBound Int b
   -&gt; CFTBoundFiles
   -&gt; Job Output)
-&gt; Closure BoundFileTreatment
-&gt; Closure
     (NominalDiffTime -&gt; CFTBound Int b -&gt; CFTBoundFiles -&gt; Job Output)
forall a b. Closure (a -&gt; b) -&gt; Closure a -&gt; Closure b
</span><span class="hs-operator hs-var">`cAp`</span></span><span>
</span><span id="line-69"></span><span>    </span><span class="annot"><span class="annottext">BoundFileTreatment -&gt; Closure BoundFileTreatment
forall a. (Static (Binary a), Typeable a) =&gt; a -&gt; Closure a
</span><span class="hs-identifier hs-var">cPure</span></span><span> </span><span class="annot"><span class="annottext">BoundFileTreatment
</span><a href="#local-6989586621679448406"><span class="hs-identifier hs-var">treatment</span></a></span><span> </span><span class="annot"><span class="annottext">Closure
  (NominalDiffTime -&gt; CFTBound Int b -&gt; CFTBoundFiles -&gt; Job Output)
-&gt; Closure NominalDiffTime
-&gt; Closure (CFTBound Int b -&gt; CFTBoundFiles -&gt; Job Output)
forall a b. Closure (a -&gt; b) -&gt; Closure a -&gt; Closure b
</span><span class="hs-operator hs-var">`cAp`</span></span><span>
</span><span id="line-70"></span><span>    </span><span class="annot"><span class="annottext">NominalDiffTime -&gt; Closure NominalDiffTime
forall a. (Static (Binary a), Typeable a) =&gt; a -&gt; Closure a
</span><span class="hs-identifier hs-var">cPure</span></span><span> </span><span class="annot"><span class="annottext">NominalDiffTime
</span><a href="#local-6989586621679448402"><span class="hs-identifier hs-var">jobTime</span></a></span><span> </span><span class="annot"><span class="annottext">Closure (CFTBound Int b -&gt; CFTBoundFiles -&gt; Job Output)
-&gt; Closure (CFTBound Int b)
-&gt; Closure (CFTBoundFiles -&gt; Job Output)
forall a b. Closure (a -&gt; b) -&gt; Closure a -&gt; Closure b
</span><span class="hs-operator hs-var">`cAp`</span></span><span>
</span><span id="line-71"></span><span>    </span><span class="annot"><span class="annottext">CFTBound Int b -&gt; Closure (CFTBound Int b)
forall a. (Static (Binary a), Typeable a) =&gt; a -&gt; Closure a
</span><span class="hs-identifier hs-var">cPure</span></span><span> </span><span class="annot"><span class="annottext">CFTBound Int b
</span><a href="#local-6989586621679448404"><span class="hs-identifier hs-var">cftBound</span></a></span><span> </span><span class="annot"><span class="annottext">Closure (CFTBoundFiles -&gt; Job Output)
-&gt; Closure CFTBoundFiles -&gt; Closure (Job Output)
forall a b. Closure (a -&gt; b) -&gt; Closure a -&gt; Closure b
</span><span class="hs-operator hs-var">`cAp`</span></span><span>
</span><span id="line-72"></span><span>    </span><span class="annot"><span class="annottext">CFTBoundFiles -&gt; Closure CFTBoundFiles
forall a. (Static (Binary a), Typeable a) =&gt; a -&gt; Closure a
</span><span class="hs-identifier hs-var">cPure</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">FilePath -&gt; CFTBoundFiles
</span><a href="#local-6989586621679448405"><span class="hs-identifier hs-var">mkFiles</span></a></span><span> </span><span class="annot"><span class="annottext">FilePath
</span><a href="#local-6989586621679448403"><span class="hs-identifier hs-var">workDir</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-73"></span><span>  </span><span class="annot"><span class="annottext">Text -&gt; (CFTBound Int b, Output) -&gt; ReaderT ClusterEnv Process ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;Computed&quot;</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">CFTBound Int b
</span><a href="#local-6989586621679448404"><span class="hs-identifier hs-var">cftBound</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Output
</span><a href="#local-6989586621679448399"><span class="hs-identifier hs-var">result</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-74"></span><span>  </span><span class="annot"><span class="annottext">KeyValMap (CFTBound Int b) Output
-&gt; CFTBound Int b -&gt; Output -&gt; ReaderT ClusterEnv Process ()
forall (m :: * -&gt; *) env a b.
(MonadIO m, MonadReader env m, HasDB env, MonadCatch m, ToJSON a,
 ToJSON b) =&gt;
KeyValMap a b -&gt; a -&gt; b -&gt; m ()
</span><span class="hs-identifier hs-var">DB.insert</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Text -&gt; KeyValMap (CFTBound Int b) Output
forall a b. Text -&gt; KeyValMap a b
</span><span class="hs-identifier hs-var">DB.KeyValMap</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;computations&quot;</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">CFTBound Int b
</span><a href="#local-6989586621679448404"><span class="hs-identifier hs-var">cftBound</span></a></span><span> </span><span class="annot"><span class="annottext">Output
</span><a href="#local-6989586621679448399"><span class="hs-identifier hs-var">result</span></a></span><span>
</span><span id="line-75"></span><span>  </span><span class="annot"><span class="annottext">Output -&gt; Cluster Output
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">Output
</span><a href="#local-6989586621679448399"><span class="hs-identifier hs-var">result</span></a></span><span>
</span><span id="line-76"></span><span>
</span><span id="line-77"></span><span id="local-6989586621679448448"><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.RemoteCompute.html#computeWithTimeLimit"><span class="hs-identifier hs-type">computeWithTimeLimit</span></a></span><span>
</span><span id="line-78"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Dict</span></span><span>
</span><span id="line-79"></span><span>     </span><span class="hs-special">(</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Show</span></span><span> </span><span class="annot"><a href="#local-6989586621679448448"><span class="hs-identifier hs-type">b</span></a></span><span>
</span><span id="line-80"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Typeable</span></span><span> </span><span class="annot"><a href="#local-6989586621679448448"><span class="hs-identifier hs-type">b</span></a></span><span>
</span><span id="line-81"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">ToJSON</span></span><span> </span><span class="annot"><a href="#local-6989586621679448448"><span class="hs-identifier hs-type">b</span></a></span><span>
</span><span id="line-82"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#ToSDP"><span class="hs-identifier hs-type">ToSDP</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679448448"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-83"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Binary</span></span><span> </span><span class="annot"><a href="#local-6989586621679448448"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-84"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Static</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#SDPFetchBuildConfig"><span class="hs-identifier hs-type">SDPFetchBuildConfig</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679448448"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-85"></span><span>     </span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#BuildInJob"><span class="hs-identifier hs-type">BuildInJob</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679448448"><span class="hs-identifier hs-type">b</span></a></span><span>
</span><span id="line-86"></span><span>     </span><span class="hs-special">)</span><span>
</span><span id="line-87"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#BoundFileTreatment"><span class="hs-identifier hs-type">BoundFileTreatment</span></a></span><span>
</span><span id="line-88"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">NominalDiffTime</span></span><span>
</span><span id="line-89"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#CFTBound"><span class="hs-identifier hs-type">CFTBound</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span> </span><span class="annot"><a href="#local-6989586621679448448"><span class="hs-identifier hs-type">b</span></a></span><span>
</span><span id="line-90"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.CFTBound.Types.html#CFTBoundFiles"><span class="hs-identifier hs-type">CFTBoundFiles</span></a></span><span>
</span><span id="line-91"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Job</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDPB.Output</span></span></span><span>
</span><span id="line-92"></span><span id="computeWithTimeLimit"><span class="annot"><span class="annottext">computeWithTimeLimit :: Dict
  (Show b, Typeable b, ToJSON b, Static (ToSDP b), Static (Binary b),
   Static (SDPFetchBuildConfig b), BuildInJob b)
-&gt; BoundFileTreatment
-&gt; NominalDiffTime
-&gt; CFTBound Int b
-&gt; CFTBoundFiles
-&gt; Job Output
</span><a href="Hyperion.Bootstrap.CFTBound.RemoteCompute.html#computeWithTimeLimit"><span class="hs-identifier hs-var hs-var">computeWithTimeLimit</span></a></span></span><span> </span><span class="annot"><span class="annottext">Dict
  (Show b, Typeable b, ToJSON b, Static (ToSDP b), Static (Binary b),
   Static (SDPFetchBuildConfig b), BuildInJob b)
</span><span class="hs-identifier hs-var">Dict</span></span><span> </span><span id="local-6989586621679448391"><span class="annot"><span class="annottext">BoundFileTreatment
</span><a href="#local-6989586621679448391"><span class="hs-identifier hs-var">treatment</span></a></span></span><span> </span><span id="local-6989586621679448390"><span class="annot"><span class="annottext">NominalDiffTime
</span><a href="#local-6989586621679448390"><span class="hs-identifier hs-var">jobTime</span></a></span></span><span> </span><span id="local-6989586621679448389"><span class="annot"><span class="annottext">CFTBound Int b
</span><a href="#local-6989586621679448389"><span class="hs-identifier hs-var">cftBound</span></a></span></span><span> </span><span id="local-6989586621679448388"><span class="annot"><span class="annottext">CFTBoundFiles
</span><a href="#local-6989586621679448388"><span class="hs-identifier hs-var">files</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-93"></span><span>  </span><span class="hs-comment">-- We ask SDPB to terminate within 90% of the jobTime. This</span><span>
</span><span id="line-94"></span><span>  </span><span class="hs-comment">-- should ensure sufficiently prompt exit as long as an</span><span>
</span><span id="line-95"></span><span>  </span><span class="hs-comment">-- iteration doesn't take 10% or more of the jobTime.</span><span>
</span><span id="line-96"></span><span>  </span><span id="local-6989586621679448387"><span class="annot"><span class="annottext">Params
</span><a href="#local-6989586621679448387"><span class="hs-identifier hs-var">solverParams'</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">IO Params -&gt; ReaderT JobEnv Process Params
forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">(IO Params -&gt; ReaderT JobEnv Process Params)
-&gt; IO Params -&gt; ReaderT JobEnv Process Params
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">NominalDiffTime -&gt; Params -&gt; IO Params
</span><a href="Hyperion.Bootstrap.CFTBound.Compute.html#setFixedTimeLimit"><span class="hs-identifier hs-var">setFixedTimeLimit</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NominalDiffTime
</span><span class="hs-number">0.9</span></span><span class="annot"><span class="annottext">NominalDiffTime -&gt; NominalDiffTime -&gt; NominalDiffTime
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">*</span></span><span class="annot"><span class="annottext">NominalDiffTime
</span><a href="#local-6989586621679448390"><span class="hs-identifier hs-var">jobTime</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">CFTBound Int b -&gt; Params
forall prec a. CFTBound prec a -&gt; Params
</span><a href="Hyperion.Bootstrap.CFTBound.Types.html#%24sel%3AsolverParams%3ACFTBound"><span class="hs-identifier hs-var hs-var">solverParams</span></a></span><span> </span><span class="annot"><span class="annottext">CFTBound Int b
</span><a href="#local-6989586621679448389"><span class="hs-identifier hs-var">cftBound</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-97"></span><span>  </span><span class="annot"><span class="annottext">BoundFileTreatment -&gt; CFTBound Int b -&gt; CFTBoundFiles -&gt; Job Output
forall b.
CanBuildSDP b =&gt;
BoundFileTreatment -&gt; CFTBound Int b -&gt; CFTBoundFiles -&gt; Job Output
</span><a href="Hyperion.Bootstrap.CFTBound.Compute.html#computeCFTBoundWithFileTreatment"><span class="hs-identifier hs-var">computeCFTBoundWithFileTreatment</span></a></span><span> </span><span class="annot"><span class="annottext">BoundFileTreatment
</span><a href="#local-6989586621679448391"><span class="hs-identifier hs-var">treatment</span></a></span><span> </span><span class="annot"><span class="annottext">CFTBound Int b
</span><a href="#local-6989586621679448389"><span class="hs-identifier hs-var">cftBound</span></a></span><span> </span><span class="hs-special">{</span><span> </span><span class="annot"><span class="annottext">$sel:solverParams:CFTBound :: Params
</span><a href="Hyperion.Bootstrap.CFTBound.Types.html#%24sel%3AsolverParams%3ACFTBound"><span class="hs-identifier hs-var">solverParams</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Params
</span><a href="#local-6989586621679448387"><span class="hs-identifier hs-var">solverParams'</span></a></span><span> </span><span class="hs-special">}</span><span> </span><span class="annot"><span class="annottext">CFTBoundFiles
</span><a href="#local-6989586621679448388"><span class="hs-identifier hs-var">files</span></a></span><span>
</span><span id="line-98"></span></pre></body></html>